bl_info = {
    "name": "Node FX",
    "author": "Black Deer Studio,xz-blender repack",
    "version": (1, 0, 0),
    "blender": (3, 4, 1),
    "category": "Shaders",
    "location": "View3D > NodeFX",
    "description": "",
    "warning": "",
    "wiki_url": "",
    "tracker_url": "",
    "support": "COMMUNITY",
}

from .download import download_zip
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "Library.zip",down_path)


import bpy
from .function_folder.node_ops import NodeOps
from .function_folder.effects_add_remove import Shader_import, Shader_remove
from .ui_folder.ui import Shader_PT_library_panel
from .ui_folder.blackdeer_info import BlackDeerInfoDocuments, BlackDeerInfoWebsite, BlackDeerInfoPanel
from .ui_folder.blackdeer_info import load_icons, clear_icons

from .function_folder.copy_mtl import SA_OT_copy_materials_1
from .ui_folder.mtlslot_ui import SA_MTL_UL_matslots_custom


from .ui_folder.preference_ui import NF_Pref_UI
from .function_folder.Assets_browser_setup import NF_OT_Library_Setup
from .function_folder.mtl_picker import OBJECT_OT_eyedropper_material_picker
from .function_folder.copy_all_mtl import OT_Copymtl

# 用於儲存預覽集合的字典
preview_collections = {}

#註冊列表
classes = [
    BlackDeerInfoDocuments,
    BlackDeerInfoWebsite,
    BlackDeerInfoPanel,

    NodeOps,
    Shader_import,
    Shader_remove,
    Shader_PT_library_panel,

    SA_OT_copy_materials_1,
    SA_MTL_UL_matslots_custom,

    NF_Pref_UI,
    NF_OT_Library_Setup,
    OBJECT_OT_eyedropper_material_picker,
    OT_Copymtl,
    
    
]

cls=classes

def register():
    
    from bpy.types import Scene
    from bpy.props import EnumProperty
    from .function_folder.effects_add_remove import update_asset_previews, asset_categories

    load_icons()

    Scene.blackdeer_node_fx_plus_my_asset_category = EnumProperty(
        name="Asset Category",
        items=asset_categories,
        description="Choose a category of assets",
    )
    Scene.my_asset_previews = EnumProperty(
        name="Asset Previews",
        items=update_asset_previews,
        description="Preview of assets",
    )

    for cls in classes:
        bpy.utils.register_class(cls)


    bpy.types.Scene.shader_ops_called = bpy.props.BoolProperty(default=False)

    # Assets_browser_setup.setup_func()
    

def unregister():
    
    from bpy.types import Scene

    clear_icons()

    del Scene.blackdeer_node_fx_plus_my_asset_category
    del Scene.my_asset_previews

    for cls in reversed(classes):
        bpy.utils.unregister_class(cls)

    del bpy.types.Scene.shader_ops_called


#主程式
if __name__ == "__main__":
    register()

