import bpy, os
import bpy.utils.previews
import webbrowser

#圖片位在Library/IMG/ui_icons/資料夾中
icon_path = os.path.join(os.path.dirname(os.path.dirname(__file__)), "Library/IMG/ui_icons")


global_icons = None

def open_webpage(url):
    webbrowser.open(url)

def load_icons():
    global global_icons
    global_icons = bpy.utils.previews.new()
    # 確保文件名和路徑是正確的
    global_icons.load("blackdeer_logo", os.path.join(icon_path, "BlackDeer_LOGO.png"), 'IMAGE')

def clear_icons():
    global global_icons
    bpy.utils.previews.remove(global_icons)


class BlackDeerInfoDocuments(bpy.types.Operator):
    """Open Documents"""  
    bl_idname = "blackdeer_node_fx_plus_info.documents"  
    bl_label = "Documents"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        open_webpage("https://blendermarket.com/products/205432/docs")
        return {'FINISHED'}
    
class BlackDeerInfoWebsite(bpy.types.Operator):
    """Open Website"""
    bl_idname = "blackdeer_node_fx_plus_info.website"  
    bl_label = "Website"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        open_webpage("https://blackdeer.studio")
        return {'FINISHED'}
    
    
class BlackDeerInfoPanel(bpy.types.Panel):
    """Displays a panel in the N panel for quick access to BlackDeer Studio's resources"""
    bl_label = "Info"
    bl_idname = "blackdeer_node_fx_plus_INFO_PT_panel"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = 'Node FX'

    def draw_header(self, context):
        if global_icons:
            self.layout.label(text="", icon_value=global_icons["blackdeer_logo"].icon_id)

    def draw(self, context):
        layout = self.layout
        box = layout.box()

        box.operator("blackdeer_node_fx_plus_info.documents", text="Documents", icon='HELP')
        box.operator("blackdeer_node_fx_plus_info.website", text="Website", icon='WORLD')
